import 'dart:io';

import 'package:kenken/kenken.dart';

// This example uses a terminal and command line,
// but most likely you want
// to draw kenken and also handle custom events in a web application.

void main() {
  var kenken = Kenken(3);
  kenken
    ..addRule([RC(1, 1)], Operation(singleValue), 1)
    ..addRule([RC(1, 2), RC(1, 3)], Operation(sum, label: '+'), 5)
    ..addRule([RC(2, 1), RC(3, 1)], Operation(diff, label: '-'), 1)
    ..addRule([RC(2, 2), RC(2, 3)], Operation(sum, label: '+'), 4)
    ..addRule([RC(3, 2), RC(3, 3)], Operation(sum, label: '+'), 3);

  while (kenken.brokenRules.isNotEmpty) {
    print(kenken.brokenRules);
    printKenken(kenken);
    // User enters a row number of cell:
    p('Enter row:');
    var row = int.tryParse(stdin.readLineSync());
    // User enters a column numer of cell:
    p('Enter col:');
    var col = int.tryParse(stdin.readLineSync());
    // User enters a value for cell:
    p('Enter value:');
    var val = int.tryParse(stdin.readLineSync());
    kenken.setValue(row, col, val);
  }

  p('DONE!');
}

void printKenken(Kenken kenken) {
  for (var rowNumber in kenken.rowOrColNumbers) {
    // print top borders
    for (var colNumber in kenken.rowOrColNumbers) {
      var cell = kenken.cellOf(RC(rowNumber, colNumber));
      p(cell.isTopBorderBold ? '--------' : '|      |');
    }
    print('');

    // print Left borders, rules, Right borders
    for (var colNumber in kenken.rowOrColNumbers) {
      var cell = kenken.cellOf(RC(rowNumber, colNumber));
      p(cell.isLeftBorderBold ? '|' : ' ');
      var ruleText = cell.ruleText;
      var cellVal = (cell.value ?? '').toString();
      var spacesCount = 6 - ruleText.length - cellVal.length - 1;
      p('$ruleText ${cellVal}' + ' ' * spacesCount);
      p(cell.isRightBorderBold ? '|' : ' ');
    }
    print('');


  }
}

void p(val) {
  stdout.write(val);
}
